#ifndef LANG_CLASS_TYPER_HPP
#define LANG_CLASS_TYPER_HPP

#include "typer.hpp"

namespace leaf
{

class class_typer : public typer::job
{
	shared_ptr<type_statement> source_ts;
	typer::context decl_context, class_context;
	shared_ptr<intr_type_custom> class_type;
public:
	class_typer( shared_ptr<type_statement> ts, typer::context decl_context );
	
	bool process( typer * ty );
	
private:
	bool class_block_done;
	
	bool has_dtor;
	shared_ptr<expr_funcdefn> build_dtor();
	
	bool is_ctor_complete, ctor_require_import;
	shared_ptr<expr_funcdefn> build_ctor();
	bool complete_ctor();
	shared_ptr<expr_funcdefn> ctor_func;
};

} //eon leaf

#endif