#ifndef LANG_CONVERSION_APPLICATOR_HPP
#define LANG_CONVERSION_APPLICATOR_HPP

#include "../core_types.hpp"
#include "fwd.hpp"
#include "type_converter.hpp"

namespace leaf
{

/**
	Applies a conversion to an expression.
*/
class conversion_applicator
{
public:
	shared_ptr<expression> apply( type_converter::convert_t const & cost, shared_ptr<expression> expr );
	shared_ptr<expression> apply( cvt_expression & cvt, shared_ptr<expression> expr );
	shared_ptr<expression> create_shared( shared_ptr<expression> expr, bool shallow = true );
	shared_ptr<expression> drop_lvalue( shared_ptr<expression> expr );
	shared_ptr<expression> apply_single( cvt_expression & cvt, shared_ptr<expression> expr );
	
	shared_ptr<expression> bind_func( shared_ptr<expression> expr );
};

} //eon leaf

#endif