#ifndef LEAF_DEFER_STATEMENT_HPP
#define LEAF_DEFER_STATEMENT_HPP

#include "statement.hpp"

namespace leaf
{

struct statement_block;

/**
	Defer statements are run at the end of a block. These are run in normal and exceptional flow (depending
	on flag)
*/
struct defer_statement : public statement
{
	virtual statement_form_t statement_form() const
	{ return sf_defer_statement; }
	
	//run only on errors, not on normal flow
	bool error_only;
	
	shared_ptr<statement_block> block;
};

} //eon leaf

#endif