#ifndef LANG_EXPRESSION_TYPER_HPP
#define LANG_EXPRESSION_TYPER_HPP

#include "typer.hpp"

namespace leaf
{

/**
	Focuses on typing expressions.
*/
class expression_typer
{
	typer::context root_ctx;
	bool no_incomplete;
public:
	expression_typer( typer::context root_ctx, bool no_incomplete )
		: root_ctx( root_ctx )
		, no_incomplete( no_incomplete )
	{  }
	
	shared_ptr<expression> process( shared_ptr<expression> expr );
private:
	shared_ptr<expression> process_expression( shared_ptr<expression> expr, 
		typer::context ctx );
	shared_ptr<expression> process_funccall( shared_ptr<expr_funccall> expr, 
		typer::context ctx );
	shared_ptr<expression> process_subscript( shared_ptr<expr_subscript> expr, 
		typer::context ctx );
	shared_ptr<expression> process_switch( shared_ptr<expr_switch> expr, 
		typer::context ctx );
	shared_ptr<expression> process_funcdefn( shared_ptr<expr_funcdefn> func, 
		typer::context ctx );
	shared_ptr<expression> process_field( shared_ptr<expr_field> field, 
		typer::context ctx );
	shared_ptr<expression> process_funccall_builtin( shared_ptr<expr_funccall> expr, 
		typer::context ctx );
	shared_ptr<expression> process_conditional( shared_ptr<expr_conditional> expr, 
		typer::context ctx );

	shared_ptr<expression> access_field_index( shared_ptr<expression> ex, 
		shared_ptr<expression> base, size_t index, typer::context ctx );
};

} //eon leaf

#endif