#ifndef LEAF_FAIL_STATEMENT_HPP
#define LEAF_FAIL_STATEMENT_HPP

#include "statement.hpp"

namespace leaf
{

/**
	Fail statements cause the program to enter error flow and start unwinding.
*/
struct fail_statement : public statement
{
	fail_level level;

	fail_statement( fail_level level ) 
		: level( level ) {
	}
	
	virtual unsigned get_flow() const { 
		return level == fail_level::resume ? flow_resume : flow_fail; 
	}
	
	virtual statement_form_t statement_form() const
	{ return sf_fail_statement; }
};

} //eon leaf

#endif