#ifndef LEAF_FOR_STATEMENT_HPP
#define LEAF_FOR_STATEMENT_HPP

#include "statement.hpp"

namespace leaf {

struct expression;

/**
	The "for" loop is a special shortcut construct which gets reduced to other statements during
	the typing process.
*/
struct for_statement : public statement {

	virtual statement_form_t statement_form() const {
		return sf_for_statement;
	}
	
	std::string item;
	shared_ptr<expression> iterable;
	shared_ptr<statement_block> block;
};

} //eon leaf
#endif