#ifndef LEAF_FWD_HPP
#define LEAF_FWD_HPP

#include "core_types.hpp"

namespace leaf
{

struct assign_statement;
struct defer_statement;
struct do_statement;
struct error_statement;
struct expression_statement;
struct fail_statement;
struct for_statement;
struct import_statement;
struct init_statement;
struct loop_flow_statement;
struct multi_statement;
struct noop_statement;
struct return_statement;
struct statement;
struct type_statement;
struct var_statement;

struct expr_binary;
struct expr_block;
struct expr_conditional;
struct expr_const_number;
struct expression;
struct expr_field;
struct expr_funccall;
struct expr_funcdefn;
struct expr_new_func;
struct expr_special_field;
struct expr_text;
struct expr_subscript;
struct expr_switch;
struct expr_symbol;
struct expr_transform;
struct expr_tuple;
struct expr_unary;
struct expr_value_list;
struct expr_with_block;
struct expr_with_sub;

struct scope;
struct statement_block;
struct extr_type_ref;
struct variable;
struct type_spec;
struct var_decl;
struct variable_context;

struct intr_type;
struct intr_type_array;
struct intr_type_compound;
struct intr_type_fixed_number;
struct intr_type_float;
struct intr_type_function;
struct intr_type_integer;
struct intr_type_number;
struct intr_type_rational;
struct intr_type_tuple;
struct intr_type_value_list;
struct intr_type_wrap;
struct intr_type_char;

struct source;
struct type_converter;
struct cvt_expression;

class module_loader;
class serial_in;
class serial_out;

enum class scope_style_t
{
	//expresisons may forward reference variables so long as a proper tree is formed
	declarative,
	//expressions may only reference prevously declared variables
	imperative,
	//a special mode for block test files, funcdefn is pending but evaluation is imperative
	//decl's are required only at the point they might actually be used (TODO: not done yet, quite unsafe now)
	dynamic,
};

/**
	Failure severity levels.
*/
enum class fail_level
{
	//not a real level, used to continue an existing failure
	resume = 0,
	unwind,
	continue_,
	recover,
	abandon,
};

} //eon leaf

#endif