#ifndef LEAF_LOOP_FLOW_STATEMENT_HPP
#define LEAF_LOOP_FLOW_STATEMENT_HPP

#include "statement.hpp"

namespace leaf
{

/**
	Loop flow statements alter the natural flow of looping blocks.
*/
struct loop_flow_statement : public statement
{
	virtual statement_form_t statement_form() const
	{ return sf_loop_flow_statement; }
	virtual unsigned get_flow() const;
	
	enum flow_t {
		//break out of the loop
		f_break,
		//next to iteration & condition of loop
		f_next,
	} flow;
};

} //eon leaf

#endif