#ifndef LANG_MULTI_STATEMENT_HPP
#define LANG_MULTI_STATEMENT_HPP

#include "core_types.hpp"
#include "statement.hpp"
#include "fwd.hpp"

namespace leaf
{

/**
	A collection of statements. This exists to allow the type to introduce new statements
	during processing.
*/
struct multi_statement : public statement
{
	statement_form_t statement_form() const
	{ return sf_multi_statement; }

	std::vector<shared_ptr<statement> > list;

	unsigned get_flow() const;
	
	void validate() const;
};

} //eon leaf

#endif