#ifndef LEAF_RETURN_STATEMENT_HPP
#define LEAF_RETURN_STATEMENT_HPP

#include "statement.hpp"

namespace leaf
{

struct statement_block;

/**
	Defer statements are run at the end of a block. These are run in normal and exceptional flow.
*/
struct return_statement : public statement
{
	//an optional value which is being returned (may be null)
	shared_ptr<expression> value;
	
	virtual statement_form_t statement_form() const
	{ return sf_return_statement; }
	virtual unsigned get_flow() const
	{ return flow_return; }
};

} //eon leaf

#endif