#ifndef LEAF_LANG_TYPE_STATEMENT_HPP
#define LEAF_LANG_TYPE_STATEMENT_HPP

#include "statement.hpp"
#include "intr_type.hpp"

#include <vector>

namespace leaf
{

/**
*/
struct type_statement : public statement
{
	statement_form_t statement_form() const
	{ return sf_type_statement; }
	
	bool is_declarative() const
	{ return true; }
	
	enum what_t {
		//new type is a prototype
		w_prototype,
		//a class type
		w_class,
		//a spec alias,
		w_alias,
	} what;
	
	std::string name;
	extr_type_ref type;
	//for prototype
	shared_ptr<type_spec> spec_type;
	//for class
	shared_ptr<statement_block> class_block;
	
	//code used to initialize the type itself (may be null)
	shared_ptr<multi_statement> init_block;
};

} //eon leaf
#endif