#ifndef VAR_STATEMENT_HPP
#define VAR_STATEMENT_HPP

#include "scope_ref.hpp"
#include "statement.hpp"

namespace leaf
{

struct expression;

struct var_statement : public statement
{
	shared_ptr<var_decl> decl;
	
	//the initial value, or mapped value
	shared_ptr<expression> value;
	//initializes the value of a reference rather than the reference itself
	bool init_refer_value;
	
	statement_form_t statement_form() const
	{ return sf_var_statement; }
	bool is_declarative() const
	{ return true; }

	var_statement() {
		init_refer_value = false;
	}
	
	void validate() const;
	
	//set during symbol scanning
	scope_ref sref;
};

} //eon leaf

#endif
