; Testing how to work with structures in LLVM
; /opt/llvm/install/bin/llc ll_struct_hand.ll -o ll_struct_hand.s && clang -o foo ll_struct_hand.s && ./foo
;
; To see how the API code would look for this
; /opt/llvm/install/bin/llc ll_struct_hand.ll -o /dev/tty --march=cpp

@.str = private unnamed_addr constant [7 x i8] c"%d-%d\0A\00"

%small = type { i32, i8 }
%large = type { i32, double, i32, double, [8 x double] }

define void @print( %small* %m ) {
	%ap = getelementptr %small* %m, i32 0, i32 0
	%bp = getelementptr %small* %m, i32 0, i32 1
	%a = load i32* %ap
	%b = load i8* %bp

	%sp = getelementptr [7 x i8]* @.str, i32 0, i32 0
	; NOTE: something does promotion of the i8 to i32 here automatically it seems...
	call i32 (i8*, ...)* @printf(i8* %sp, i32 %a, i8 %b)
	ret void
}

define void @dprint( %small %m ) {
	%a = extractvalue %small %m, 0
	%b = extractvalue %small %m, 1
	
	%sp = getelementptr [7 x i8]* @.str, i32 0, i32 0
	; NOTE: something does promotion of the i8 to i32 here automatically it seems...
	call i32 (i8*, ...)* @printf(i8* %sp, i32 %a, i8 %b)
	ret void
}

@gvalue = global %small undef

define i32 @main() {
	%m = alloca %small
	%a = getelementptr %small* %m, i32 0, i32 0
	store i32 5, i32* %a
	%b = getelementptr %small* %m, i32 0, i32 1
	store i8 3, i8 * %b
	call void @print( %small* %m )
	
	%dm = call %small @get_small()
	call void @dprint( %small %dm )
	
	%g = getelementptr %small* @gvalue, i32 0
	store %small %dm,%small* %g
	call void @print( %small* %g )
	ret i32 0
}

declare i32 @printf(i8*, ...)

define %small @get_small() {
	%m1 = insertvalue %small undef, i32 5, 0
	%m2 = insertvalue %small %m1, i8 3, 1
	ret %small %m2
}

define %large @get_large() {
	%m1 = insertvalue %large undef, i32 1, 0
	%m2 = insertvalue %large %m1, double 2.0, 1
	%m3 = insertvalue %large %m2, i32 3, 2
	%m4 = insertvalue %large %m3, double 4.0, 3
	ret %large %m4
}

define void @store_small() {
	%g = getelementptr %small* @gvalue, i32 0
	%m1 = insertvalue %small undef, i32 5, 0
	%m2 = insertvalue %small %m1, i8 3, 1
	store %small %m2, %small* %g
	ret void
}
