#include "ir/block.hpp"
#include "ir/function.hpp"
#include "ir/instruction.hpp"

namespace ir
{

shared_ptr<value> block::make_temp( shared_ptr<type const> dt )
{ 
	return owner_function.make_temp( dt ); 
}

void block::validate() const
{
	for( size_t i=0; i < items.size(); ++i )
	{
		if( items[i].an_instruction )
			items[i].an_instruction->validate();
			
		if( items[i].a_block )
			items[i].a_block->validate();
	}
}

void block::append( block & o )
{
	items.insert( items.end(), o.items.begin(), o.items.end() );
}

} //eon ir