#include "lang/do_statement.hpp"
#include "lang/statement_block.hpp"

namespace leaf
{

unsigned do_statement::get_flow() const
{
	unsigned combine = 0;
	bool has_else = false;
	for( auto & eli : expr_list ) {
		combine |= eli.block->get_flow();
		if( !eli.cond )
			has_else = true;
	}
	
	if( !has_else )
		combine |= flow_sequence;
		
	//loops end next/break flow
	if( loop )
		combine &= ~(flow_loop_break | flow_loop_next);
		
	//catch failures
	if( on_error )
		combine &= ~(flow_resume | flow_fail);
		
	return combine;
}

} //eon leaf