#include "lang/module_loader.hpp"
#include "lang/serial.hpp"

#include <fstream>

namespace leaf {

module_loader::module_loader( std::string const & leaf_path )
	: leaf_path( leaf_path )
{
}

std::string module_loader::resolve_dynlink( std::string const & mod_name )
{
	return leaf_path + "/libs/" + mod_name + ".so";
}

std::string module_loader::resolve_dynload( std::string const & mod_name )
{
	return leaf_path + "/libs/" + mod_name + ".so";
}

std::string module_loader::resolve_static_core( std::string const & part )
{
	return leaf_path + "/leaf_" + part + ".o";
}

std::string module_loader::resolve_dyn_core( std::string const & part )
{
	return leaf_path + "/libleaf_" + part + ".so";
}

shared_ptr<serial_in> module_loader::resolve_import( std::string const & part )
{	
	auto name = leaf_path + "/libs/" + part + ".lo";
	std::ifstream in( name );
	
	return make_shared<serial_in>(in);
}


}
