#include "lang/multi_statement.hpp"

namespace leaf 
{

unsigned multi_statement::get_flow() const
{
	if( list.empty() )
		return flow_sequence;
	return list.back()->get_flow();
}
	
void multi_statement::validate() const
{
	for( size_t i=0; i < list.size(); ++i ) {
		list[i]->validate();
		//multi must be a sequence to the end
		if( i != (list.size()-1)) {
			STATE_CHECK( list[i]->get_flow() == flow_sequence );
		}
	}
}

} //eon leaf