#include "lang/statement_block.hpp"
#include "lang/scope.hpp"
#include "lang/init_statement.hpp"

namespace leaf
{

statement_block::statement_block( scope_style_t scope_style )
	: symbols( scope::create( scope_style ) )
{
	flow = 0;
}

statement_block::~statement_block()
{
}

void statement_block::validate() const
{
	STATE_CHECK(symbols);
	for( auto & s : list ) {
		STATE_CHECK( s );
		s->validate();
	}
}

void statement_block::update_flow()
{
	flow = 0;
	for( auto & s : list )
		flow |= s->get_flow();
}

bool statement_block::is_complete() const
{
	for( auto & s : list )
		if( !s->complete )
			return false;
	return true;
}

} //eon leaf
